
#include "uassert.h"

/*
 * DESCRIPTION
 * The strcspn() function calculates the length of the initial segment of
 * s which consists entirely of characters not in reject.
 * RETURN VALUE
 * The strcspn() function returns the number of characters in the initial
 * segment of s which are not in the string reject.
 */

size_t utf8_strcspn(const utf8_char *s, const utf8_char *reject)
{
    size_t count = 0;
    
    assert(s != NULL);
    assert(reject != NULL);

    while (*s != '\0') {
        const uint32 ch32 = plainutf8_scan(s, &s);
        const utf8_char *needle;
        for (needle = reject; *needle != '\0'; ) {
            if (ch32 == plainutf8_scan(needle, &needle))
              return count;
        }
        /* This "ch32" was not found in "reject". */
        ++count;
    }
    return count;
}

