
#include "uassert.h"

/*
 * DESCRIPTION
 * The strlen() function calculates the length of the string s, not
 * including the terminating '\0' character.
 *
 * RETURN VALUE
 * The strlen() function returns the number of characters in s.
 */

size_t utf8_strlen(const utf8_char *s)
{
    size_t count = 0;

    assert(s != NULL);

    while (*s != '\0') {
        (void)plainutf8_scan(s, &s);
        ++count;
    }
    return count;
}

