
#include "uassert.h"

/*
 * DESCRIPTION
 * The strspn() function calculates the length of the initial segment of s
 * which consists entirely of characters in accept.
 * RETURN VALUE
 * The strspn() function returns the number of characters in the initial
 * segment of s which consist only of characters from accept.
 */

size_t utf8_strspn(const utf8_char *s, const utf8_char *accept)
{
    size_t count = 0;
    
    assert(s != NULL);
    assert(accept != NULL);

    while (*s != '\0') {
        const uint32 ch32 = plainutf8_scan(s, &s);
        const utf8_char *needle;
        for (needle = accept; *needle != '\0'; ) {
            if (ch32 == plainutf8_scan(needle, &needle))
              goto found_ch;
        }
        /* This "ch32" was not found in "accept". */
        return count;
      found_ch:
        ++count;
    }
    return count;
}

